package com.googlecode.mycontainer.commons.rhino;

import org.mozilla.javascript.tools.shell.Global;

public class DefaultRhinoBoxBuilder implements RhinoBoxBuilder {

	private static final DefaultRhinoBoxBuilder ME = new DefaultRhinoBoxBuilder();

	private final Global GLOBAL;

	private final RhinoBox RHINO_BOX_GLOBAL;

	private RhinoBox box;

	private DefaultRhinoBoxBuilder() {
		org.mozilla.javascript.tools.shell.Main.shellContextFactory = RhinoBox
				.getContextFactory();
		GLOBAL = org.mozilla.javascript.tools.shell.Main.getGlobal();
		GLOBAL.init(RhinoBox.getContextFactory());

		RHINO_BOX_GLOBAL = new RhinoBox(GLOBAL);
	}

	public RhinoBox getRhinoBox() {
		return ME.getSingletonBox();
	}

	public RhinoBox getGlobalInstance() {
		return RHINO_BOX_GLOBAL;
	}

	private RhinoBox getSingletonBox() {
		RhinoBox ret = null;
		ret = box;
		if (ret != null) {
			return ret;
		}
		synchronized (this) {
			ret = box;
			if (ret == null) {
				ret = new RhinoBox();
				box = ret;
			}
		}
		return ret;
	}

	public static RhinoBox getBox() {
		return ME.getSingletonBox();
	}

	public static DefaultRhinoBoxBuilder instance() {
		return ME;
	}

	public void reset() {
		box = null;
	}

}
